﻿using Prism.Navigation;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace PopupAcceptDecline.ViewModels
{
    public class MainPageViewModel : ViewModelBase
    {

        public string ChangeLabel { get; set; } = "Some text for now";

        public Command NavigateToPageB => new Command(async () => await NavigationService.NavigateAsync("PageB"));


        public MainPageViewModel(INavigationService navigationService)
            : base(navigationService)
        {
            Title = "Main Page";
        }


        public override async void OnNavigatedTo(INavigationParameters parameters)
        {

            //First attempt for Busy

            ShowBusy(true);

            // do some busywork here, call APIs etc
            await Task.Delay(100);

            ShowBusy(false);

        }

    }
}
