﻿using Prism.Mvvm;
using Prism.Navigation;
using Syncfusion.SfBusyIndicator.XForms;
using Syncfusion.XForms.PopupLayout;
using Xamarin.Forms;

namespace PopupAcceptDecline.ViewModels
{
    public class ViewModelBase : BindableBase, IInitialize, INavigationAware, IDestructible
    {
        protected INavigationService NavigationService { get; private set; }

        public string Title { get; set; }


        //this is used in the ShowBusy
        private SfPopupLayout _popupLayout;
        private SfBusyIndicator _busyIndicator;


        public ViewModelBase(INavigationService navigationService)
        {
            NavigationService = navigationService;

            _popupLayout = new SfPopupLayout();
        }


        protected void ShowBusy(bool show)
        {
            DataTemplate contentTemplateView = new DataTemplate(() =>
            {
                StackLayout stack = new StackLayout();
                _busyIndicator = new SfBusyIndicator();
                _busyIndicator.ViewBoxHeight = 100;
                _busyIndicator.ViewBoxWidth = 100;
                _busyIndicator.IsBusy = true;
                stack.Children.Add(_busyIndicator);
                return stack;
            });

            _popupLayout.PopupView.HeaderTitle = string.Empty;
            _popupLayout.PopupView.ContentTemplate = contentTemplateView;
            _popupLayout.PopupView.ShowHeader = false;
            _popupLayout.PopupView.PopupStyle.BorderColor = Color.Transparent;
            _popupLayout.PopupView.ShowFooter = false;
            _popupLayout.PopupView.ShowCloseButton = false;
            _popupLayout.PopupView.AutoSizeMode = AutoSizeMode.Height;
            _popupLayout.PopupView.BackgroundColor = Color.Transparent;

            _popupLayout.IsOpen = show;

        }



        public virtual void Initialize(INavigationParameters parameters)
        {

        }

        public virtual void OnNavigatedFrom(INavigationParameters parameters)
        {

        }

        public virtual void OnNavigatedTo(INavigationParameters parameters)
        {

        }

        public virtual void Destroy()
        {

        }
    }
}
